# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `rime-api-key` header.

    The version of the OpenAPI document: 1.0
    Contact: dev@robustintelligence.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ri.apiclient.models.detailed_upgrade_status import DetailedUpgradeStatus
from typing import Optional, Set
from typing_extensions import Self

class AgentDesiredState(BaseModel):
    """
    AgentDesiredState
    """ # noqa: E501
    custom_values: Optional[Dict[str, StrictStr]] = Field(default=None, description="Example:   {     \"rimeAgent.images.agentImage.registry\": \"docker.io\",   }", alias="customValues")
    upgrade_status: Optional[DetailedUpgradeStatus] = Field(default=None, alias="upgradeStatus")
    version: Optional[StrictStr] = Field(default=None, description="Desired agent release version. E.g., 2.7.1 This is always set to the current control plane version.")
    __properties: ClassVar[List[str]] = ["customValues", "upgradeStatus", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AgentDesiredState from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of upgrade_status
        if self.upgrade_status:
            _dict['upgradeStatus'] = self.upgrade_status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AgentDesiredState from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "customValues": obj.get("customValues"),
            "upgradeStatus": DetailedUpgradeStatus.from_dict(obj["upgradeStatus"]) if obj.get("upgradeStatus") is not None else None,
            "version": obj.get("version")
        })
        return _obj


