# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `rime-api-key` header.

    The version of the OpenAPI document: 1.0
    Contact: dev@robustintelligence.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class FeatureRelationshipInfo(BaseModel):
    """
    Specifies configuration values for feature relationships.
    """ # noqa: E501
    compute_feature_relationships: Optional[StrictBool] = Field(default=None, description="Specifies whether to compute feature relationships.", alias="computeFeatureRelationships")
    compute_numeric_feature_relationships: Optional[StrictBool] = Field(default=None, description="Specifies whether to compute feature relationships for numeric columns.", alias="computeNumericFeatureRelationships")
    features_to_profile: Optional[List[StrictStr]] = Field(default=None, alias="featuresToProfile")
    ignore_nan_for_feature_relationships: Optional[StrictBool] = Field(default=None, description="Specifies whether to ignore NaN values when computing feature relationships.", alias="ignoreNanForFeatureRelationships")
    num_feats_to_profile: Optional[StrictStr] = Field(default=None, description="Number of features to profile for smart feature sampling.", alias="numFeatsToProfile")
    __properties: ClassVar[List[str]] = ["computeFeatureRelationships", "computeNumericFeatureRelationships", "featuresToProfile", "ignoreNanForFeatureRelationships", "numFeatsToProfile"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FeatureRelationshipInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FeatureRelationshipInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "computeFeatureRelationships": obj.get("computeFeatureRelationships"),
            "computeNumericFeatureRelationships": obj.get("computeNumericFeatureRelationships"),
            "featuresToProfile": obj.get("featuresToProfile"),
            "ignoreNanForFeatureRelationships": obj.get("ignoreNanForFeatureRelationships"),
            "numFeatsToProfile": obj.get("numFeatsToProfile")
        })
        return _obj


