# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `rime-api-key` header.

    The version of the OpenAPI document: 1.0
    Contact: dev@robustintelligence.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class TestSensitivity(str, Enum):
    """
    TestSensitivity specifies how sensitive to make a RIME test. This setting controls the thresholds for what constitutes a 'failure' in a given test case, with TEST_SENSITIVITY_LESS_SENSITIVE allowing the widest margin of error, and TEST_SENSITIVITY_MORE_SENSITIVE allowing the narrowest.
    """

    """
    allowed enum values
    """
    TEST_SENSITIVITY_LESS_SENSITIVE = 'TEST_SENSITIVITY_LESS_SENSITIVE'
    TEST_SENSITIVITY_DEFAULT = 'TEST_SENSITIVITY_DEFAULT'
    TEST_SENSITIVITY_MORE_SENSITIVE = 'TEST_SENSITIVITY_MORE_SENSITIVE'
    TEST_SENSITIVITY_UNSPECIFIED = 'TEST_SENSITIVITY_UNSPECIFIED'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of TestSensitivity from a JSON string"""
        return cls(json.loads(json_str))


