# coding: utf-8

"""
    Robust Intelligence Firewall REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` header. Your AI Firewall Agent domain forms the base of the URL for REST API calls. To find the Agent domain in the Robust Intelligence UI, click AI Firewall: Settings icon: Firewall Settings. Find your agent in the Firewall Agent Status: Agents Setup page, and copy its URL from the table.

    The version of the OpenAPI document: 1.0
    Contact: dev@robustintelligence.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class PiiEntityType(str, Enum):
    """
     - PII_ENTITY_TYPE_ABA_ROUTING_NUMBER: Default entity types.  - PII_ENTITY_TYPE_DATETIME: Non-default entity types.
    """

    """
    allowed enum values
    """
    PII_ENTITY_TYPE_ABA_ROUTING_NUMBER = 'PII_ENTITY_TYPE_ABA_ROUTING_NUMBER'
    PII_ENTITY_TYPE_AU_ABN = 'PII_ENTITY_TYPE_AU_ABN'
    PII_ENTITY_TYPE_AU_ACN = 'PII_ENTITY_TYPE_AU_ACN'
    PII_ENTITY_TYPE_AU_MEDICARE_NUMBER = 'PII_ENTITY_TYPE_AU_MEDICARE_NUMBER'
    PII_ENTITY_TYPE_AU_TFN = 'PII_ENTITY_TYPE_AU_TFN'
    PII_ENTITY_TYPE_CREDIT_CARD_NUMBER = 'PII_ENTITY_TYPE_CREDIT_CARD_NUMBER'
    PII_ENTITY_TYPE_EMAIL = 'PII_ENTITY_TYPE_EMAIL'
    PII_ENTITY_TYPE_IBAN_CODE = 'PII_ENTITY_TYPE_IBAN_CODE'
    PII_ENTITY_TYPE_IP_ADDRESS = 'PII_ENTITY_TYPE_IP_ADDRESS'
    PII_ENTITY_TYPE_MEDICAL_LICENSE_NUMBER = 'PII_ENTITY_TYPE_MEDICAL_LICENSE_NUMBER'
    PII_ENTITY_TYPE_PHONE_NUMBER = 'PII_ENTITY_TYPE_PHONE_NUMBER'
    PII_ENTITY_TYPE_NHS_NUMBER = 'PII_ENTITY_TYPE_NHS_NUMBER'
    PII_ENTITY_TYPE_US_BANK_NUMBER = 'PII_ENTITY_TYPE_US_BANK_NUMBER'
    PII_ENTITY_TYPE_US_DRIVERS_LICENSE_NUMBER = 'PII_ENTITY_TYPE_US_DRIVERS_LICENSE_NUMBER'
    PII_ENTITY_TYPE_US_ITIN = 'PII_ENTITY_TYPE_US_ITIN'
    PII_ENTITY_TYPE_US_PASSPORT_NUMBER = 'PII_ENTITY_TYPE_US_PASSPORT_NUMBER'
    PII_ENTITY_TYPE_US_SSN = 'PII_ENTITY_TYPE_US_SSN'
    PII_ENTITY_TYPE_DATETIME = 'PII_ENTITY_TYPE_DATETIME'
    PII_ENTITY_TYPE_NRP = 'PII_ENTITY_TYPE_NRP'
    PII_ENTITY_TYPE_LOCATION = 'PII_ENTITY_TYPE_LOCATION'
    PII_ENTITY_TYPE_PERSON = 'PII_ENTITY_TYPE_PERSON'
    PII_ENTITY_TYPE_ORGANIZATION = 'PII_ENTITY_TYPE_ORGANIZATION'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PiiEntityType from a JSON string"""
        return cls(json.loads(json_str))


